function p=Horner(a, xe)
%--------------------------------------------------------------------------
% This function implements the Horner scheme for evaluating
% the interpolating polynomial on a set of evaluation points
%--------------------------------------------------------------------------
% Inputs
% a: vector of coefficients
% xe: vector of target points
%
% Output
% p: the polynomial evaluated at all targets
%-----------------------------------------------
n=length(a);
for i=1:length(xe);
p(i)=a(n);
for k=n-1:-1:1
p(i)=p(i)*xe(i)+a(k);
end
end