function [x1, k, err, p, m]=Newton1(f, fp, x0, tol, kmax,alfa)
% ------------------------------------
% inputs
% f = funzione
% fp = derivata prima della funzione f
% x0 = punto iniziale
% tol = tolleranza
% kmax = numero massimo iterazioni

% output
% x1 = soluzione approssimata
% k = numero iterazioni
% err = vettore degli errori realtivi
% p = approssimazione dell'ordine
% m = molteplicita' della radice
%-------------------------------------
x1=x0-f(x0)/fp(x0);
k=1;
err(k)=abs(x1-x0)/abs(x1);
m(1)=1;  %molteplicita' della radice

while( err(k)> tol & k<= kmax)
   xold=x0;
   x0=x1;
   x1=x0-f(x0)/fp(x0);
   k=k+1;
   err(k)=abs(x1-x0)/abs(x1);
   p(k)=log(abs(x1-alfa))/log(abs(x0-alfa));
   m(k)=(x0-xold)/(2*x0-x1-xold);
end
if (k> kmax)
    disp('Non converge nel nr max d''iterazioni ')
    return
end
return