function [x1, k, err]=Newton2(f, fp, x0, tol, kmax, m)
% ------------------------------------
% inputs
% f = funzione
% fp = derivata prima della funzione f
% x0 = punto iniziale
% tol = tolleranza
% kmax = numero massimo iterazioni
% m= molteplicita'
%
% output
% x1 = soluzione approssimata
% k = numero iterazioni
% err = vettore degli errori realtivi
%-------------------------------------
x1=x0-m*f(x0)/fp(x0);
k=1;
err(k)=abs(x1-x0)/abs(x1);

while( err(k)> tol & k<= kmax)
   x0=x1;
   x1=x0-m*f(x0)/fp(x0);
   k=k+1;
   err(k)=abs(x1-x0)/abs(x1);
end
if (k> kmax)
    disp('Non converge nel nr max d''iterazioni ')
    return
end
return