% Esercizio 2 del 28 agosto 2017
clear all
close all
f=@(x) sin(x.^2-cos(x/2));

t=linspace(0,pi,100); % punti target
ft=f(t); %punzione nei punti target

n=5
% parte a)
x=linspace(0,pi,n); %punti equispaziati

y=f(x); %funzione nei punti d'interpolazione

  %matrice di Vandermonde nella base monomiale
V=vander(x); 

% risolvo i sistemi di Vandermonde
a=fliplr(V)\y'; 
p=Horner(a,t);
plot(t,f(t),'r', t, p, 'b.-', x, y, 'o') 
title(['punti = ',num2str(n)])
legend('funzione','polinomio','punti')
cV=cond(V) % condizionamento in norma 2
error_V=norm(p-ft, inf) %errore in norma infinito

% parte b)

for i=1:n,
    L(:,i)=Lagtarget(x,t',i);
end

p1=L*y';
figure(2);
plot(t,f(t),'r', t, p1, 'g.-',x,y,'o') 
title(['punti = ',num2str(n)])
legend('funzione','polinomio','punti')
cL=cond(L) % condizionamento in norma 2
error_L=norm(p1'-ft, inf) %errore in norma inf

% si nota che error_a=error_b per l' esistenza e unicita'
% del polinomio d'interpolazione, mentre i numeri di 
% condizionamento sono molto diversi


%--------------------------------
pause
% parte c)
% ho fatto un ciclo e memorizzato numero di condizionamento
% ed errori 

k=1;

for n=10:25

x=linspace(0,pi,n); %punti equispaziati

y=f(x); %funzione nei punti d'interpolazione


% parte c1)

  %matrice di Vandermonde nella base monomiale
V=vander(x); 

% risolvo i sistemi di Vandermonde
a=fliplr(V)\y'; 
p=Horner(a,t);

cV(k)=cond(V); % condizionamento in norma 2
error_V(k)=norm(p-ft, inf); %errore in norma infinito

% parte c2)

for i=1:n,
    L(:,i)=Lagtarget(x,t',i);
end

p1=L*y';
cL(k)=cond(L);
error_L(k)=norm(p1'-ft, inf);

k=k+1;
end

figure(3);
m=length(cV);
semilogy(1:m,cV,'r', 1:m, cL, 'g.-') 
legend('cond V', 'cond L');

figure(4);
semilogy(1:m,error_V,'r', 1:m, error_L, 'g.-') 
legend('error V', 'error L');

% si nota, come noto, che la matrice di Vandermonde 
% e' peggio condizionata di quella di Lagrange e che
% al crescere di n l'errore inizia ad oscillare nel
% caso di Vandermonde. Questo implica che al crescere
% di n non si converge